/*
 * File : dlReject.h
 *
 * Description : This file contains the class declaration for the
 * dlReject class.
 */

#ifndef _dlReject_h_
#define _dlReject_h_


#include "dlInfoXfer.h"
/*
 * Class : dlReject
 *
 * Description : This class inherits from dlInfoXfer, and provides
 * the functionality to implement the dlReject state of the
 * data-link layer. Note that the dlReject state is a special
 * case of the information transfer phase, and is reached after
 * having transmitted a REJ. We are waiting for an I-frame with
 * the proper N(s) sequence number while in this state. Only
 * HandleIframe and GetSupervisoryFrame() need to be redefined.
 * Also, HandleRejTimer needs to be defined to handle the timeout
 * of a REJ timer.
 */

class dlReject : public dlInfoXfer {
 public:
	dlReject(dllayer *dl);
	virtual ~dlReject() {}
	virtual dlStateMachine *HandleIframe(int &errorCode);
	virtual void PrintState(); 

	virtual dlStateMachine *HandleRejTimer(int &errorCode);

 protected:
	virtual int GetSupervisoryFrame();
};

#endif
